{*******************************************************}
{                                                       }
{       ֮ HappyViewer  (UFO ļ)      }
{                                                       }
{       Copyright (c) 1999  HappyBird             }
{                                                       }
{*******************************************************}
unit DataSave;

interface

uses
  Windows, Forms, sysutils, Dialogs, UnitConst;

type
  TScaleType = (None, Horz, Vert);

type
  TSaveData = record
    BookMark: array[0..5] of string[128];
    ScaleType: TScaleType;
    Scale: Integer;
    DefaultScale: Boolean;
    StandardScale: Boolean;
    AutoPage: Boolean;
    AutoSave: Boolean;
    PlayDelay: integer; //new
    PlayDirection: integer; //new
  end;

procedure ReadData;
procedure WriteData;

var
  SaveData: TSaveData;

implementation

procedure ReadData;
var
  F: file of TSaveData;
  FileName: string;

begin
  FileName := ExtractFilePath(Application.ExeName) + 'HappyViewer.dat';
  try
    AssignFile(F, FileName);
    Reset(F);
    Read(F, SaveData);
    CloseFile(F);
  except
    on EInOutError do
      with SaveData do
      begin
        BookMark[0] := '';
        BookMark[1] := '';
        BookMark[2] := '';
        BookMark[3] := '';
        BookMark[4] := '';
        BookMark[5] := '';
        ScaleType := None;
        Scale := 100;
        StandardScale := True;
        AutoPage := True;
        AutoSave := False;
        PlayDelay := 1;
        PlayDirection := 0;
      end;
  end;
end;

procedure WriteData;
var
  F: file of TSaveData;
  FileName: string;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'HappyViewer.dat';
  try
    AssignFile(F, FileName);
    ReWrite(F);
    Write(F, SaveData);
    CloseFile(F);
  except
  else
    MessageDlg(hsFileWriteError, mtError, [mbOk], 0);
  end;
end;

end.

