unit Disk;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Inifiles;

type
  TfrmDisk = class(TForm)
    GroupBox1: TGroupBox;
    Label5: TLabel;
    ComboBox1: TComboBox;
    ButtonScan: TButton;
    ListTemp: TListBox;
    Label6: TLabel;
    Edit5: TEdit;
    Label1: TLabel;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    StringGrid1: TStringGrid;
    Button2: TButton;
    Button4: TButton;
    GroupBox3: TGroupBox;
    ListSerial: TListBox;
    ListName: TListBox;
    ListTemp2: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonScanClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    function FindDiectory(Directory: string; List: TListBox): integer;
    procedure ListNameClick(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2Change(Sender: TObject);
    procedure Save;
  private
    { Private declarations }
    Selected: integer;
    Volume, Serial: string;
//    DirNumber: integer;
//    DiskNumber: Integer;
//    TotalNumber: Integer;
//    DiskSerial: array[1..1000] of string;
    IniFile: TIniFile;
    fModify: Boolean;
  public
    { Public declarations }
  end;

var
  frmDisk: TfrmDisk;

implementation

{$R *.DFM}

procedure TfrmDisk.FormCreate(Sender: TObject);
var
  TempChar: Char;
begin
  for TempChar := 'C' to 'Z' do
    if GetDriveType(PChar(TempChar + ':\')) = Drive_CDROM then
      ComboBox1.Items.Add(TempChar + ':\');
  if ComboBox1.Items.Count = 0 then ButtonScan.Enabled := False
  else ComboBox1.ItemIndex := 0;
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'ufo-cd.ini');
end;

procedure TfrmDisk.FormShow(Sender: TObject);
var
  i: integer;
begin
  GroupBox2.Enabled := False;
  StringGrid1.RowCount := 2;
  StringGrid1.ColCount := 2;
  StringGrid1.Cells[0, 0] := 'Ŀ¼';
  StringGrid1.Cells[1, 0] := '';
  StringGrid1.Cells[0, 1] := '';
  StringGrid1.Cells[1, 1] := '';
  Edit2.Text := '0';
  Edit3.Text := 'ҵ';
  Edit5.Text := 'Volume';
  Edit1.Text := '0000-0000';
  Button2.Enabled := False;
  Selected := -1;
  fModify := False;

  ListName.Clear;
  ListSerial.Clear;
  IniFile.ReadSections(ListSerial.Items);
  for i := 0 to ListSerial.Items.Count - 1 do
    ListName.Items.Add(IniFile.ReadString(ListSerial.Items.Strings[i], '', ''));
end;

procedure TfrmDisk.FormDestroy(Sender: TObject);
begin
  IniFile.Free;
end;


procedure TfrmDisk.StringGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  fModify := True;
end;

procedure TfrmDisk.Edit2Change(Sender: TObject);
begin
  fModify := True;
end;

procedure TfrmDisk.ListNameClick(Sender: TObject);
var
  i, j, t: integer;
begin
  for i := 0 to ListSerial.Items.Count - 1 do
    if ListName.Selected[i] then
    begin
      if Selected = i then exit;
      if fModify then
        if Application.MessageBox('ѾģǷ̣', '', MB_YESNO + MB_DEFButton1) = IDYES then save;
      Selected := i;
      ListTemp.Clear;
      IniFile.ReadSectionValues(ListSerial.Items.Strings[i], ListTemp.Items);
      Edit1.Text := ListSerial.Items.Strings[i];
      Edit5.Text := ListTemp.Items.Values[''];
      Edit2.Text := ListTemp.Items.Values[''];
      Edit3.Text := ListTemp.Items.Values[''];
      t := 1;
      for j := 0 to ListTemp.Items.Count - 1 do
        if PChar(ListTemp.Items.Strings[j])^ = '\' then
        begin
          t := t + 1;
          StringGrid1.RowCount := t;
          StringGrid1.Cells[0, t - 1] := ListTemp.Items.Names[j];
          StringGrid1.Cells[1, t - 1] := ListTemp.Items.Values[ListTemp.Items.Names[j]];
        end;
    end;
  GroupBox2.Enabled := True;
  Button2.Enabled := True;
  fModify := False;
end;

function SlashSep(const Path, S: string): string;
begin
  if AnsiLastChar(Path)^ <> '\' then
    Result := Path + '\' + S
  else
    Result := Path + S;
end;

function TfrmDisk.FindDiectory(Directory: string; List: TListBox): integer;
var
  Status: Integer;
  SearchRec: TSearchRec;
begin
  Result := 0;
  Status := FindFirst(SlashSep(Directory, '*.*'), faDirectory, SearchRec);
  try
    while Status = 0 do
    begin
      if (SearchRec.Attr and faDirectory = faDirectory) then
      begin
        if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
        begin
          List.Items.Add(SlashSep(Directory, SearchRec.Name));
          Result := Result + FindDiectory(SlashSep(Directory, SearchRec.Name), List);
          Inc(Result);
        end;
      end;
      Status := FindNext(SearchRec);
    end;
  finally
    FindClose(SearchRec);
  end;
end;

procedure TfrmDisk.ButtonScanClick(Sender: TObject);
var
  i, Num, DirNum: integer;
  num1, num2, num3: DWord;
  Buffer: array[0..255] of Char;
begin
  if fModify then
    if Application.MessageBox('ѾģǷ̣', '', MB_YESNO + MB_DEFButton1) = IDYES then save;
  fModify := False;
  if not GetVolumeInformation(PChar(ComboBox1.Text), buffer, 255, @num1, num2, num3, nil, 0) then exit;
  ButtonScan.Enabled := False;
  Volume := Buffer;
  Serial := IntToHex(num1 div 65536, 4) + '-' + IntToHex(num1 mod 65536, 4);
  Num := -1;
  for i := 0 to ListSerial.Items.Count - 1 do
    if ListSerial.Items.Strings[i] = Serial then
    begin
      Num := i;
      break;
    end;
  Selected := Num;
  ListName.ItemIndex := Num;
  Edit1.Text := Serial;
  Edit5.Text := Volume;
  if Num <> -1 then
  begin
    Edit2.Text := IniFile.ReadString(Serial, '', '1234');
    Edit3.Text := IniFile.ReadString(Serial, '', 'ҵ0001');
  end
  else
  begin
    Edit2.Text := '1234';
    Edit3.Text := 'ҵ0001';
  end;
  ListTemp2.Clear;
  DirNum := FindDiectory(ComboBox1.Text, ListTemp2);
  if DirNum > 0 then
    StringGrid1.RowCount := DirNum + 1
  else
    StringGrid1.RowCount := 2;
  for i := 1 to DirNum do
  begin
    StringGrid1.Cells[0, i] := ListTemp2.Items.Strings[i - 1];
    if num = -1 then
      StringGrid1.Cells[1, i] := StrRScan(PChar(StringGrid1.Cells[0, i]), '\') + 1
    else
      StringGrid1.Cells[1, i] := IniFile.ReadString(Serial, PChar(StringGrid1.Cells[0, i]) + 2, '');
  end;

  GroupBox2.Enabled := True;
  Button2.Enabled := True;
  ButtonScan.Enabled := True;
end;

procedure TfrmDisk.Button4Click(Sender: TObject);
begin
  if fModify then
    if Application.MessageBox('ѾģǷ̣', '', MB_YESNO + MB_DEFButton1) = IDYES then save;
  IniFile.UpdateFile;
  Hide;
end;

procedure TfrmDisk.Button2Click(Sender: TObject);
begin
  Save;
end;

procedure TfrmDisk.Save;
var
  i: integer;
begin
  if fModify = False then exit;
  fModify := False;
  with IniFile do
  begin
    WriteString(Serial, '', Volume);
    WriteString(Serial, '', Edit2.Text);
    WriteString(Serial, '', Edit3.Text);
    for i := 1 to StringGrid1.RowCount - 1 do
      WriteString(Serial, PChar(StringGrid1.Cells[0, i]) + 2, StringGrid1.Cells[1, i]);
    UpdateFile;
  end;
  if Selected = -1 then
  begin
    ListName.Clear;
    ListSerial.Clear;
    IniFile.ReadSections(ListSerial.Items);
    for i := 0 to ListSerial.Items.Count - 1 do
    begin
      ListName.Items.Add(IniFile.ReadString(ListSerial.Items.Strings[i], '', ''));
      if ListSerial.Items.Strings[i] = Serial then Selected := i;
    end;
    ListName.ItemIndex := Selected;
  end;
end;

end.

