unit ReadDisk;

interface

uses
  Classes,SysUtils;

type
  ReadDiskThread = class(TThread)
  private
    { Private declarations }
    procedure ReadJPEG;
  protected
    procedure Execute; override;
  end;

implementation
uses
  UnitMain;

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure ReadDisk.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ ReadDisk }

procedure ReadDiskThread.ReadJPEG;
var
  M: TMemoryStream;
  S: string;
begin
  if Form1.FileListbox1.FileName = ''  then
  begin
    ListLoad[0] := False;
  end;
  if ListLoad[0] = True then exit;
  try
    try
      S := Form1.FileListBox1.FileName;
      M := TmemoryStream.Create;
      M.LoadFromFile(Form1.FileListBox1.FileName);
      if LowerCase(Copy(S, Length(S) - 2, 3)) = 'ufo' then
        M.WriteBuffer(Buffer, 10);
      M.Seek(0, soFromBeginning);
      JPEGList[0].LoadFromStream(M);

            ListLoad[0] := True ;
    finally
      M.Destroy;
    end;
  except
    ListLoad[0] := False;
  end;
end;

procedure ReadDiskThread.Execute;
begin
  { Place thread code here }
  while not Terminated do
    Synchronize(ReadJPEG);
end;

end.

